/*
  TO-DO LIST --------------
	 -- MIGRAR WEB A MODBUS TCP
     X  REVISAR FUNCION DE NIVEL DE TANQUE TEMPORIZAR.. MUCHO DELAY...!!!!!
     -- ENCENDER LED TESTIGO DE FUNCIONAMIENTO DE BOMBA
     -- CONTROL DE HUMEDAD PARA EVITAR ENCENDER EL RIEGO / BOTON
     X  BOTON PARA ENCENDER BOMBA DESDE EL PANEL PARA RIEGO MANUAL. USO DE EV. PRIORITARIO SOBRE RIEGO DE JARDIN
     X  BOTONERA DE 5 PULSADORES A ENTRADA ANALOGICA. PROGRAMAR BOTONES.
     ---- BOTON 1: ESTADO DEL SISTEMA (% DE RIEGO, CONSUMO ELECTRICO, ETC)
     ---- BOTON 2: ENCENDIDO/APAGADO DE BOMBA (RIEGO MANUAL)
     ---- BOTON 3:
     ---- BOTON 4:
     ---- BOTON 5: ABRIR PORTON ;)
     -- LUCES EXTERIOR
     -- LUCES INTERIOR
     -- DIMMER ESTAR
     -- SISTEMA RF PARA ENCEDER FUENTE DECORATIVA
     -- ARMAR RELE SHIELD 2 RELE PARA FUENTE DECORATIVA
     -- CONFIGURACION BLINK
     -- INICIAR RIEGO DE PARQUE MANUALMENTE DESDE BLYNK
     -- DATALOGER EN SD CARD
     -- MODIFICAR VARIABLES DESDE WEB Y GUARDAR DATOS SD.
     -- PAGINA WEB DEL SISTEMA
     -- VINCULAR SISTEMA A RASPBERRY PI ó SIMILAR
  PINES DIGITALES LIBRES = 0,1,14-17,30-33,53
  PINES ANALOGICOS LIBRES =  A0-A11 / DAC0-DAC1 / CANRX-CANTX
  PINES PWM/DIGITALES LIBRES = 3-13
*/

// include the library code:
#include <SPI.h>
#include <Ethernet.h>
#include <Wire.h>
#include <RTClib.h>
#include <LiquidCrystal.h>
#include <DHT.h>
#include <SD.h>

//-------{SYSTEM DEBUG}-----------
#define SystemDEBUG // Comentar par detener el debug
//#define TankDEBUG // Debug de Funcion control de Tanque
//#define RiegoDEBUG // Debug de funcion de Riego de parque
//#define keyDEBUG // Debug de funcion de botones
//-------{CONFIGURACION ETHERNET}-----------
// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED }; // Use your MAC address
byte ip[] = { 192, 168, 1, 7 };                      // no DHCP so we set our own IP address
byte subnet[] = { 255, 255, 255, 0 };                // subnet mask
byte gateway[] = { 192, 168, 1, 1 };                 // internet access via router
byte dns_server[] = {192, 168, 1, 1};

//-------{PINES}-----------
// RTC USA LOS PINES 20,21 - SDA/SCL
// LCD USA LOS PINES 22,23,24,25,26,27)

byte pulsadores  = A6;
byte analogMeter = 2; //Indicador de nivel de agua analógico PIN-PWM

// SENSOR ULTRASONIDO PARA NIVEL DE AGUA
byte echoPin = 18; // Pin eco.
byte trigPin = 19; // Pin disparador.

// SENSOR DE MOVIMIENTO
byte stairDWNSensor = 28;
byte stairUPSensor = 29;

// SENSOR DE TEMPERATURA
byte DHT11_PIN = 34; //Interior
byte DHT22_PIN = 35; //Exterior

// MODULO RELE 8 PUERTOS - pines 36-43
byte Puerto1_8 = 36; //Luz Estar
byte Puerto2_8 = 37; //Luz Comedor
byte Puerto3_8 = 38; //Luces esteriores frente
byte Puerto4_8 = 39; // LIBRE
byte Puerto5_8 = 40; // LIBRE
byte Puerto6_8 = 41; //EV Riego Frente Manual
byte Puerto7_8 = 42; //EV Tanque de agua
byte Puerto8_8 = 43; //EV riego Frente

// MODULO RELE 4 PUERTOS - pines 44-47
byte Puerto1_4 = 44; //Bomba de riego
byte Puerto2_4 = 45; //EV Patio trasero
byte Puerto3_4 = 46; //Luces Patio
byte Puerto4_4 = 47; //EV Hacia el frente Sector 2

byte ldr_ext = 48;

byte led1 = 49;
byte led2 = 50;
byte led3 = 51;
byte led4 = 52;

//------------{VARIABLES}--------------
#define DHTTYPE11 DHT11   // DHT 11
#define DHTTYPE22 DHT22   // DHT 22  (AM2302), AM2321
bool riegoON = false;
bool bombaON = false;
bool flagEscalera  = false;
bool flagEscaleraa = false;
byte key          = 0;
float porcentaje; // Porcentaje de avance de proceso
int ldr           = 0;
int stateStairUP  = 0;
int stateStairDWN = 0;
int intTanqChek   = 600000;
int timerEscalera = 0;
int HoraInicio    = 0;
int MinutoInicio  = 0;
int durRiego      = 0; // Duracion de riego en minutos
const int nroMenu = 5;
char tituloMenu[nroMenu][15] = {"1.Tanque 1", "2.Tanque 2", "3.Tanque 3", "4.Tanque 4"};
uint32_t volumesize;
unsigned int tiempoActual = millis();
unsigned int previousMillis = 0;
String settingsFile = "/files/settings.txt";

//-------{OBJETOS}-----------
LiquidCrystal lcd(22, 23, 24, 25, 26, 27); // Inicializa LCD ----- initialize the library with the numbers of the interface pins
RTC_DS1307 rtc; // Creamos el objeto "rtc" para el reloj ---- SDA CABLE ROJO / SCL CABLE MARRON
DHT dht11(DHT11_PIN, DHTTYPE11); // Inicializa SONDA DHT-11 -----
DHT dht22(DHT22_PIN, DHTTYPE22); // Inicializa SONDA DHT-22 -----
EthernetServer server(80);

//------------{PARAMETROS PARA SD CARD}--------------
File myFile;
Sd2Card card;
SdVolume volume;
SdFile root;

//------------------------------------------------------------------------------------------------------------------
void setup() {
  //------ SET UP PIN MODE
  // Sensor de Ultrasonido para Nivel de Agua en tanque
  pinMode(trigPin, OUTPUT); // Establece pin como salida
  pinMode(echoPin, INPUT); // Establece pin como entrada
  pinMode(analogMeter, OUTPUT); //Indicador analogico
  pinMode(stairUPSensor, INPUT); //Escalera Arriba
  pinMode(stairDWNSensor, INPUT); //Escalera Abajo
  // Placa x 8 relay
  pinMode(Puerto1_8, OUTPUT); //Luz Estar
  pinMode(Puerto2_8, OUTPUT); //Luz Comedor
  pinMode(Puerto3_8, OUTPUT); //Luces esteriores frente
  pinMode(Puerto4_8, OUTPUT);
  pinMode(Puerto5_8, OUTPUT);
  pinMode(Puerto6_8, OUTPUT); //EV Riego Frente Manual
  pinMode(Puerto7_8, OUTPUT); //EV Tanque de agua
  pinMode(Puerto8_8, OUTPUT); //EV riego Frente
  // Placa x 4 relay
  pinMode(Puerto1_4, OUTPUT); //Bomba
  pinMode(Puerto2_4, OUTPUT); //EV Patio trasero
  pinMode(Puerto3_4, OUTPUT); //Luces Patio
  pinMode(Puerto4_4, OUTPUT); //EV Hacia el frente Sector 2
  pinMode(ldr_ext, INPUT); // LDR
  pinMode(led1, OUTPUT); // led
  pinMode(led2, OUTPUT); // led
  pinMode(led3, OUTPUT); // led
  pinMode(led4, OUTPUT); // led
  // APAGAMOS RELAYS
  digitalWrite(Puerto1_4, HIGH);

  //------ SET UP INTERRUPCIONES

  // ------ SERIAL PORT
  Serial.begin(115200);

  // ------ INICIALIZA SD CARD
  digitalWrite(53, HIGH); // Desactivamos w5100 SPI mientras inicia SD
  if (!card.init(SPI_HALF_SPEED, 4)) {
#ifdef SystemDEBUG
    Serial.println("Falla al iniciar SD-Card: Revise:");
    Serial.println("* la tarjeta esta presente?");
    Serial.println("* revise la velocidad de datos");
#endif
    return;
  } else {
    SD.begin(4);
    //Serial.println("Escritura Correcta - Tarjeta Iniciada CORRECTAMENTE.");
  }

  //------ INICIAMOS ETHERNET
  Ethernet.begin(mac, ip, dns_server, gateway, subnet);

  //------ INICIAMOS WEBSERVER
  server.begin();

  //------ SET UP THE LCD's ROWS & COLUMNS
  lcd.begin(16, 2);

  //------ Inicializa sonda DHT
  dht11.begin();
  dht22.begin();

  //------ RTC
  Wire.begin(); // INICIAMOS COMUNICACION IC2
  rtc.begin(); // INICIAMOS COMUNICACION CON MODULO rtc1307
  //rtc.adjust(DateTime(__DATE__, __TIME__)); // CONFIGURACION HORA Y FECHA POR COMPUTADORA

  digitalWrite(trigPin, LOW); // Pone el pin a un estado logico bajo
  /*
    //------ REPORTE DE ESTADO
    #ifdef SystemDEBUG
    Serial.println("INICIANDO......");
    Serial.println(ARDUINO);
    Serial.print("\nIniciando SD card...");
    switch (card.type()) {
        Serial.println("SD1");
        break;
      case SD_CARD_TYPE_SD2:
        Serial.println("SD2");
        break;
      case SD_CARD_TYPE_SDHC:
        Serial.println("SDHC");
        break;
      default:
        Serial.println("No se Reconoce Tarjeta.");
    }
    if (!volume.init(card)) {
      Serial.println("No se puede encontrar particion FAT16/FAT32.\nAsegurese que la tarjeta esta formateada.");
      return;
    }
    Serial.print("\nTipo de FAT ");
    Serial.println(volume.fatType(), DEC);
    volumesize = volume.blocksPerCluster();    // clusters are collections of blocks
    volumesize *= volume.clusterCount();       // we'll have a lot of clusters
    volumesize *= 512;                            // SD card blocks are always 512 bytes
    Serial.print("Tamaño (Mbytes): ");
    volumesize /= 1024;
    Serial.println(volumesize);
    Serial.print("IP = ");
    Serial.println(Ethernet.localIP());
    Serial.println("Web Server OK");
    Serial.print("DHT LIBRARY VERSION: ");
    Serial.println(DHT_LIB_VERSION);
    Serial.println("<=======================================>");
    Serial.println("Sistema e-HOME LISTO");
    Serial.print("Fecha y Hora: ");
    Serial.print(SystemDate());
    Serial.print(" - ");
    Serial.println(SystemTime());
    Serial.println("<=======================================>");
    Serial.println();
    #endif
  */
  TempHumIn();
  TempHumOut();
  readSDSettings();
}

void loop() {
  key = analogRead(pulsadores);
  DateTime now = rtc.now();
  StairsDWN();
  StairsUP();

  /*
    Serial.println(key);
    if (key > 9 && key < 19) { //BOTON 1
    if (key > 52 && key < 66){ //BOTON 2
    if (key > 23 && key < 47) Serial.println("");
    if (key > 120 && key < 152){ //BOTON 3
    if (key > 239 && key < 250){ //BOTON 4
    if (key > 208 && key < 227){ //BOTON 5
  */
TempHumOut();
  if (tiempoActual - previousMillis > intTanqChek) {
    nivelTanque();
    TempHumIn();
    TempHumOut();
    previousMillis = tiempoActual;
  }
  if (!bombaON) {
    riegoJardin();
  }
}

//------------{FUNCIONES}--------------
void nivelTanque()
{
  long duration, cm; // Declara variables
  // Pulso de 10us para inicial el modulo
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH); //Devuelve la longitud del pulso del pin Echo en us
  // Convierte el tiempo de recepción del eco en distancia:
  cm = microsecondsToCentimeters(duration);
  int valor = map(cm, 2, 120, 0, 255); //calibrar medidor analogico.
  analogWrite(analogMeter, valor);
  if (valor >= 100 && !bombaON) {
    digitalWrite(Puerto7_8, LOW); //Abre EV Frente LLenado de Tanque
    digitalWrite(Puerto4_4, LOW); //EV Hacia el frente Sector 2
    delay(300);
    digitalWrite(Puerto2_4, HIGH); // Cierra EV sector 1
    digitalWrite(Puerto8_8, HIGH); // Cierra EV sector 2
    digitalWrite(Puerto1_4, LOW); // Enciende Bomba. Lógica inversa
    bombaON = true;
  }
  if (valor <= 2 && bombaON && !riegoON) {
    digitalWrite(Puerto1_4, HIGH); // Apaga Bomba. Lógica inversa
    delay(300);
    digitalWrite(Puerto7_8, HIGH); // Cierre EV Frente LLenado de Tanque
    digitalWrite(Puerto4_4, HIGH); // Cierre EV Hacia el frente Sector 2
    bombaON = false;
  }
#ifdef TankDEBUG
  Serial.print("Litros: ");
  Serial.println(valor);
  Serial.print(cm);
  Serial.print("cm, ");
  Serial.print(duration);
  Serial.print("eco ");
  Serial.println();
  Serial.print("LLenando Tanque");
  Serial.println(riegoON);
#endif
}
// Calcula la distancia en cm
long microsecondsToCentimeters(long microseconds) {
  return microseconds / 58;
}

void StairsDWN()
{
  stateStairDWN = digitalRead(stairDWNSensor);
  if (stateStairDWN == HIGH) {
    if (!flagEscalera && !flagEscaleraa) {
      timerEscalera = tiempoActual + 10000;
      flagEscalera = true;
      digitalWrite(led1, HIGH);
      delay(200);
      digitalWrite(led2, HIGH);
      delay(200);
      digitalWrite(led3, HIGH);
      delay(200);
      digitalWrite(led4, HIGH);
    }
  }
  if (flagEscalera && tiempoActual > timerEscalera) {
    flagEscalera = false;
    digitalWrite(led1, LOW);
    delay(200);
    digitalWrite(led2, LOW);
    delay(200);
    digitalWrite(led3, LOW);
    delay(200);
    digitalWrite(led4, LOW);
  }
}

void StairsUP()
{
  stateStairUP = digitalRead(stairUPSensor);
  if (stateStairUP == HIGH) {
    if (!flagEscaleraa && !flagEscalera) {
      timerEscalera = tiempoActual + 10000;
      flagEscaleraa = true;
      digitalWrite(led4, HIGH);
      delay(200);
      digitalWrite(led3, HIGH);
      delay(200);
      digitalWrite(led2, HIGH);
      delay(200);
      digitalWrite(led1, HIGH);
    }
  }
  if (flagEscaleraa && tiempoActual > timerEscalera) {
    digitalWrite(led4, LOW);
    delay(200);
    digitalWrite(led3, LOW);
    delay(200);
    digitalWrite(led2, LOW);
    delay(200);
    digitalWrite(led1, LOW);
    flagEscaleraa = false;
  }
}

void TempHumIn()
{
  // Reading temperature or humidity takes about 250 milliseconds!
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  float hum11 = dht11.readHumidity();
  // Read temperature as Celsius (the default)
  float temp11 = dht11.readTemperature();

  // Check if any reads failed and exit early (to try again).
  #ifdef SystemDEBUG
  /*if (isnan(hum11) || isnan(temp11) || isnan(hum22) || isnan(temp22) ) {
    Serial.println("Failed to read from DHT sensor!");
    return;
  }*/
  // Compute heat index in Celsius (isFahreheit = false)
  float hic11 = dht11.computeHeatIndex(temp11, hum11, false);
  Serial.println("DHT11");
  Serial.print("Humidity: ");
  Serial.print(hum11);
  Serial.print(" %\t");
  Serial.print("Temperature: ");
  Serial.print(temp11);
  Serial.print(" *C ");
  Serial.print("Heat index: ");
  Serial.print(hic11);
  Serial.print(" *C ");
  Serial.println("-----------------------");
#endif
}

void TempHumOut()
{
  // Reading temperature or humidity takes about 250 milliseconds!
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  float hum22 = dht22.readHumidity();
  // Read temperature as Celsius (the default)
  float temp22 = dht22.readTemperature();

  // Check if any reads failed and exit early (to try again).
  #ifdef SystemDEBUG
  /*if (isnan(hum11) || isnan(temp11) || isnan(hum22) || isnan(temp22) ) {
    Serial.println("Failed to read from DHT sensor!");
    return;
  }*/
  // Compute heat index in Celsius (isFahreheit = false)
  float hic22 = dht22.computeHeatIndex(temp22, hum22, false);
  Serial.println("DHT22");
  Serial.print("Humidity: ");
  Serial.print(hum22);
  Serial.print(" %\t");
  Serial.print("Temperature: ");
  Serial.print(temp22);
  Serial.print(" *C ");
  Serial.print("Heat index: ");
  Serial.print(hic22);
  Serial.print(" *C ");
  Serial.println("-----------------------");
#endif
}

void readSDSettings() {
  char character;
  String settingName;
  String settingValue;
  myFile = SD.open(settingsFile);
  if (myFile) {
    while (myFile.available()) {
      character = myFile.read();
      while ((myFile.available()) && (character != '[')) {
        character = myFile.read();
      }
      character = myFile.read();
      while ((myFile.available()) && (character != '=')) {
        settingName = settingName + character;
        character = myFile.read();
      }
      character = myFile.read();
      while ((myFile.available()) && (character != ']')) {
        settingValue = settingValue + character;
        character = myFile.read();
      }
      if (character == ']') {
        // Apply the value to the parameter
        //return settingValue;
        applySetting(settingName, settingValue);
        // Reset Strings
        settingName = "";
        settingValue = "";
      }
    }
    // close the file:
    myFile.close();
  } else {
    // if the file didn't open, print an error:
#ifdef SystemDEBUG
    Serial.println("error al abrir settings.txt");
#endif
  }
}

void applySetting(String settingName, String settingValue) {
  if (settingName == "t_inicio") {
    String y;
    String z;
    y = settingValue.substring(0, 2);
    z = settingValue.substring(3, 5);
    HoraInicio = y.toInt();
    MinutoInicio = z.toInt();
  }
  if (settingName == "t_duracion") {
    durRiego = settingValue.toInt();
  }
}

void riegoJardin() {
  DateTime relojRiego = rtc.now();
  if (relojRiego.hour() == HoraInicio && relojRiego.minute() == MinutoInicio && !riegoON) {
    riegoON = true;
    bombaON = true;
    durRiego = (durRiego * 60000) + tiempoActual;
    digitalWrite(Puerto2_4, LOW); // Abre EV sector 1. Lógica inversa
    delay(300);
    digitalWrite(Puerto1_4, LOW); // Enciende Bomba. Lógica inversa
  }
  if (bombaON && riegoON) {
    if (durRiego >= millis()) {
      porcentaje = ((float)millis() / durRiego) * 100;
      if (porcentaje > 50) {
        digitalWrite(Puerto8_8, LOW); // Abre EV sector 2.
        digitalWrite(Puerto2_4, HIGH); // Cierra EV sector 1. Lógica inversa
      }
    } else {
      digitalWrite(Puerto1_4, HIGH); // Apaga Bomba
      delay(300);
      digitalWrite(Puerto2_4, HIGH); // Cierra EV sector 1
      digitalWrite(Puerto8_8, HIGH); // Cierra EV sector 2
      riegoON = false;
      bombaON = false;
      porcentaje = 0;
    }
  }
#ifdef RiegoDEBUG
  Serial.println();
  Serial.print("Regando:");
  Serial.println(riegoON);
  Serial.print("Progreso");
  Serial.print(porcentaje);
  Serial.print(" %");
#endif
}

String SystemDate()
{
  String Fecha;
  DateTime reloj = rtc.now();
  if (reloj.day() <= 9) Fecha.concat("0");
  Fecha.concat(reloj.day());
  Fecha.concat("/");
  if (reloj.month() <= 9) Fecha.concat("0");
  Fecha.concat(reloj.month());
  Fecha.concat("/");
  Fecha.concat(reloj.year());
  return Fecha;
#ifdef SystemDEBUG
  Serial.println();
  Serial.print("Funcion Fecha: ");
  Serial.println(Fecha);
#endif
}

String SystemTime()
{
  String Hora;
  DateTime reloj = rtc.now();
  if (reloj.hour() <= 9) Hora.concat("0");
  Hora.concat(reloj.hour());
  Hora.concat(":");
  if (reloj.minute() <= 9) Hora.concat("0");
  Hora.concat(reloj.minute());
  Hora.concat(":");
  if (reloj.second() <= 9) Hora.concat("0");
  Hora.concat(reloj.second());
  return Hora;
#ifdef SystemDEBUG
  Serial.println();
  Serial.print("Funcion Hora: ");
  Serial.println(Hora);
#endif
}
